import numpy as np
import matplotlib.pyplot as plt
import random

#https://www.youtube.com/watch?v=bzC5cdxZcOM
#Les données : La dernière donnée en x_entrer correspond aux données de la fleur dont on cherche la couleur
x_entrer_init = np.array(([3,4.5],[1, 2], [1, 3], [2, 1.5], [2, 3], [5,0.5], [5,1], [6,2], [6,1.5]), dtype=float) # données d'entrer
y = np.array(([1],[1], [1], [1],[1],[0],[0],[0],[0]), dtype=float) # données de sortie /  1 = rouge /  0 = bleu

#valeurs à modifier
epsilon = 1.2
itérations = 20

#construction de la droite 1 (verte) de séparation : équation 0 = w_1x+w_2y+b
w_1 = random.random()
w_1 = -w_1
w_2 = random.random()
b= 0



#fonction cerveau 1 : L =liste de points et C = couleur des points
def cerveau(u,v, L, C):
    compteur=0#le nombre de points rouge au dessus de la droite
    comptbleu = 0#le nombre de points bleu en dessous de la droite
    nbrebleu =0 #compte le nombre de points bleus
    
    for i in range(len(L)):
        if C[i] == 0: 
            nbrebleu =nbrebleu +1
        if u*L[i][0]+v*L[i][1]+b > 0 and C[i] == 1:
            print(L[i][0],L[i][1],C[i])
            compteur =compteur +1
        if u*L[i][0]+v*L[i][1]+b < 0 and C[i] == 0:
            comptbleu = comptbleu+1
        
    print(compteur,comptbleu)
        
    
    
    if compteur<comptbleu:
        return u,v*epsilon
    else:
        if compteur==comptbleu:
            return u,v
        else:
            return u*epsilon,v
    
   



#Pour afficher les data
x_rouge = []
y_rouge = []
x_bleu = []
y_bleu = []
for i in range(len(y)):
    if y[i][0] == 1:
        x_rouge.append(x_entrer_init[i][0])
        y_rouge.append(x_entrer_init[i][1])
    else:
        x_bleu.append(x_entrer_init[i][0])
        y_bleu.append(x_entrer_init[i][1])


plt.scatter(x_rouge, y_rouge, c = 'red')
plt.scatter(x_bleu, y_bleu, c = 'blue')

#DROITE 1 VERTE
#pour afficher la droite
x_droite = []
y_droite = []
for i in range(100):
    x_droite.append(i/20)
    y_droite.append((-w_1*i/(20*w_2)+b/w_2))
plt.scatter(x_droite, y_droite, c = 'green')

#temps d'apprentissage
for i in range(itérations):
    w_1 = cerveau(w_1,w_2, x_entrer_init,y)[0]
    w_2 = cerveau(w_1,w_2, x_entrer_init,y)[1]
#droite finale JAUNE
x_droite = []
y_droite = []
for i in range(100):
    x_droite.append(i/20)
    y_droite.append((-w_1*i/(20*w_2)+b/w_2))
plt.scatter(x_droite, y_droite, c = 'yellow')


plt.show()